/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreMissingvalue.TCoreMissingvaluePath;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.records.TCoreMissinglistRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreMissinglist extends TableImpl<TCoreMissinglistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_missinglist</code>
     */
    public static final TCoreMissinglist T_CORE_MISSINGLIST = new TCoreMissinglist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreMissinglistRecord> getRecordType() {
        return TCoreMissinglistRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_missinglist.lastchange</code>.
     */
    public final TableField<TCoreMissinglistRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_missinglist.pk</code>. id of missing
     * list
     */
    public final TableField<TCoreMissinglistRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "id of missing list");

    /**
     * The column <code>common_dd.t_core_missinglist.name</code>. optional name
     * for this missinglist
     */
    public final TableField<TCoreMissinglistRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "optional name for this missinglist");

    private TCoreMissinglist(Name alias, Table<TCoreMissinglistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreMissinglist(Name alias, Table<TCoreMissinglistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missinglist</code> table
     * reference
     */
    public TCoreMissinglist(String alias) {
        this(DSL.name(alias), T_CORE_MISSINGLIST);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missinglist</code> table
     * reference
     */
    public TCoreMissinglist(Name alias) {
        this(alias, T_CORE_MISSINGLIST);
    }

    /**
     * Create a <code>common_dd.t_core_missinglist</code> table reference
     */
    public TCoreMissinglist() {
        this(DSL.name("t_core_missinglist"), null);
    }

    public <O extends Record> TCoreMissinglist(Table<O> path, ForeignKey<O, TCoreMissinglistRecord> childPath, InverseForeignKey<O, TCoreMissinglistRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_MISSINGLIST);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreMissinglistPath extends TCoreMissinglist implements Path<TCoreMissinglistRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreMissinglistPath(Table<O> path, ForeignKey<O, TCoreMissinglistRecord> childPath, InverseForeignKey<O, TCoreMissinglistRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreMissinglistPath(Name alias, Table<TCoreMissinglistRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreMissinglistPath as(String alias) {
            return new TCoreMissinglistPath(DSL.name(alias), this);
        }

        @Override
        public TCoreMissinglistPath as(Name alias) {
            return new TCoreMissinglistPath(alias, this);
        }

        @Override
        public TCoreMissinglistPath as(Table<?> alias) {
            return new TCoreMissinglistPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreMissinglistRecord, Integer> getIdentity() {
        return (Identity<TCoreMissinglistRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreMissinglistRecord> getPrimaryKey() {
        return Keys.PK_CORE_MISSINGLIST;
    }

    private transient TCoreMissingvaluePath _tCoreMissingvalue;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_missingvalue</code> table
     */
    public TCoreMissingvaluePath tCoreMissingvalue() {
        if (_tCoreMissingvalue == null)
            _tCoreMissingvalue = new TCoreMissingvaluePath(this, null, Keys.T_CORE_MISSINGVALUE__FK_MISSINGLIST.getInverseKey());

        return _tCoreMissingvalue;
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_variable</code> table
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, null, Keys.T_CORE_VARIABLE__FK_VAR_MISSINGLIST.getInverseKey());

        return _tCoreVariable;
    }

    @Override
    public TCoreMissinglist as(String alias) {
        return new TCoreMissinglist(DSL.name(alias), this);
    }

    @Override
    public TCoreMissinglist as(Name alias) {
        return new TCoreMissinglist(alias, this);
    }

    @Override
    public TCoreMissinglist as(Table<?> alias) {
        return new TCoreMissinglist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissinglist rename(String name) {
        return new TCoreMissinglist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissinglist rename(Name name) {
        return new TCoreMissinglist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissinglist rename(Table<?> name) {
        return new TCoreMissinglist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissinglist where(Condition condition) {
        return new TCoreMissinglist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissinglist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissinglist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissinglist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissinglist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissinglist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissinglist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissinglist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissinglist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissinglist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
